#include<reg51.h>
#include<intrins.h>
#include<rtx51tny.h>
#define uchar unsigned char
#define uint unsigned int
#define  PU   0x01 
#define  STOP   0x02 
#define  RESET   0x03 
#define  CLI_INT  0x04 
#define  RD_STATUS 0x05 
#define  RD_PLAY_PTR   0x06 
#define  PD   0x07 
#define  RD_REC_PTR   0x08 
#define  RD_DEVID 0x09 
#define  G_ERASE 0x43 
#define  RD_APC   0x44 
#define  WR_APC1   0x45  
#define  WR_APC2   0x65 
#define  WR_NVCFG   0x46 
#define  CHK_MEM 0x49 
#define  SET_PLAY   0x80 
#define  SET_REC   0x81 
#define  SET_ERASE   0x82
#define   NOP  _nop_() 

sbit SS   = P2^7 ;
sbit SCLK = P2^6 ;
sbit MOSI = P2^5 ;  
sbit MISO = P2^4 ;
sbit s = P2^3;
sbit b = P2^2;
sbit q = P2^1;
sbit w = P2^0;
sbit READ=P3^0;
//sbit OVER=P3^6;
sbit POL=P3^7;
uchar wan,qian,bai,shi,ge;
uchar SR0_L; 
uchar SR0_H; 
uchar SR1; 
uchar ID,APCL=0,APCH=0;
/*ܶ()*/
uchar code tab[]={
                    0xc0,/*0*/
                    0xf9,/*1*/
                    0xa4,/*2*/
                    0xb0,/*3*/
                    0x99,/*4*/
                    0x92,/*5*/
                    0x82,/*6*/
                    0xf8,/*7*/
                    0x80,/*8*/
                    0x90,/*9*/
                 };
//-------------------------------------------------------------

//ļַ

//-------------------------------------------------------------

uint caToneAdd[34]=
{
0x0010,0x0015,/*0*/
0x0016,0x001A,/*1*/
0x001B,0x001F,/*2*/ 
0x0020,0x0024,/*3*/
0x0025,0x0029,/*4*/
0x002A,0x002E,/*5*/
0x002F,0x0033,/*6*/
0x0034,0x0037,/*7*/
0x0038,0x003C,/*8*/
0x003D,0x0041,/*9*/
0x0042,0x0047,/*ʮ*/
0x0048,0x004C,/**/
0x004D,0x0050,/*ǧ*/
0x0051,0x0054,/**/
0x0055,0x005D,/**/
0x005E,0x0065,/*Ƿ*/
0x0066,0x006A,/**/
};

uint V;       //װɼĵѹֵ

sbit P0_7=P0^7;/*Сʾλ*/

void Delay(uint ms)    //ʱ12MʱԼ1ms
{
 uchar i;
 while(ms--)
 for(i=0;i<123;i++);
}

void I_delay(void)     //΢ʱ

{ 
  NOP;NOP;NOP;NOP;NOP;NOP;NOP;NOP;NOP;
  NOP;NOP;NOP;NOP;NOP;NOP;NOP;NOP;NOP;

}

 
//----------------------------------------------------------------
//ΪISD1760Ӻ//

//   : SPISendData( )

// : SPIݣݣӳ

//----------------------------------------------------------------

uchar SPISendData(uchar BUF_ISD)

{  uchar i,dat=BUF_ISD;  SCLK=1;  SS=0; 

 for(i=0;i<8;i++)
  {
     SCLK=0;
     I_delay();
     if(dat&0x01)
     {
     MOSI=1;
     }
     else
     {
     MOSI=0;
     }
     dat>>=1;
     if(MISO)
     {
     dat|=0x80;
     }
     SCLK=1;
     I_delay();
     }
     MOSI=0;  // SS=1;
     return(dat);

} 

/************************************************************************** 

*    ԭ: void RdStatus(void); 

*        : ȡ״̬ 

**************************************************************************/ 

void RdStatus(void)
 {
   SPISendData(RD_STATUS);
   SPISendData(0x00);
   SPISendData(0x00);
   SS=1;
   Delay(10);               //ӳ10ms
   SR0_L =SPISendData(RD_STATUS);
   SR0_H =SPISendData(0x00);
   SR1 =SPISendData(0x00);
   SS=1;
   Delay(10);

} 

/************************************************************************** 

*    ԭ: void ClrInt(void); 

*        : ж 

**************************************************************************/ 

void ClrInt(void)

{  

 SPISendData(CLI_INT);
 SPISendData(0x00);
 SS=1;
 Delay(10);

} 
/************************************************************************** 

/*    ԭ: void RD_APC(void); 

/*        : ȡAPC 

/**************************************************************************/ 
void RdAPC (void)

{
  SPISendData(RD_APC);
  SPISendData(0x00);
  SPISendData(0x00);
  SPISendData(0x00);
  SS=1;
  Delay(10);               //ӳ10ms
  SR0_L =SPISendData(RD_APC);
  SR0_H =SPISendData(0x00);
  APCL =SPISendData(0x00);
  APCH =SPISendData(0x00);
  SS=1;
  Delay(10);

} 

/************************************************************************** 

*    ԭ: void ISD_WR_NVCFG(void); 

*        : дĴ 

**************************************************************************/ 

void ISD_WR_NVCFG(void)

{  

 SPISendData(WR_NVCFG);
 SPISendData(0x00);
 SS=1;
 Delay(10);

} 

/************************************************************************** 

*    ԭ: void ISD_WR_APC2(uchar voiceValue); 

*        : APC2 

**************************************************************************/ 

void ISD_WR_APC2(void)



{
  SPISendData(WR_APC2);
  SPISendData(0x28); //0xa80xafС,0xa0ȥ¼ʱļ
  SPISendData(0x0c); //D11=1,SETPLAYģʽ£ִеEOMԶ

                               //SET_PLAYִеһEOMԶڶοʼ
  SS=1;
  Delay(10);
  ISD_WR_NVCFG(); //дĴ
  
 }




/************************************************************************** 

*    ԭ: void ISD_CHK_MEM(void);

*        : ռ 

**************************************************************************/ 

void ISD_CHK_MEM(void)

 {
  SPISendData(CHK_MEM);
  SPISendData(0x00);
  SS=1;
  Delay(10);

 } 

/************************************************************************** 

*    ԭ: void ISD_Reset(void); 

*        : λ 

**************************************************************************/ 

void ISD_Reset(void)
 {
   SPISendData(RESET);
   SPISendData(0x00);
   SS=1;
   Delay(50);

} 



/************************************************************************** 

*    ԭ: void ISD_Stop(void); 

*        : ֹͣ 

**************************************************************************/ 

//void ISD_Stop(void)

//{  

// SPISendData(STOP);
// SPISendData(0x00);
// SS=1;
// Delay(50);

//} 

/************************************************************************** 

*    ԭ: void ISD_PU(void); 

*        : ϵ 

**************************************************************************/ 

void  ISD_PU(void)

{
  SPISendData(PU);
  SPISendData(0x00);
  SS=1;
  Delay(50);

} 

/************************************************************************** 

*    ԭ: void ISD_PD(void); 

*        :  

**************************************************************************/ 

void ISD_PD(void)

{
  SPISendData(PD);
  SPISendData(0x00);
  SS=1;
  Delay(10);

} 

 

/************************************************************************** 

*    ԭ: void RdStatus(void); 

*        : ȡID 

**************************************************************************/ 

//uchar RD_DevID(void)

//{
//  SPISendData(RD_DEVID);
//  SPISendData(0x00);
//  SPISendData(0x00);
//  SS=1;
//  Delay(10);               //ӳ10ms
//  SR0_L =SPISendData(RD_DEVID);
//  SR0_H =SPISendData(0x00);
//  ID =SPISendData(0x00);
//  SS=1;
//  Delay(10);
//  return(ID);

//} 

/************************************************************************** 

*    ԭ: void GetToneAdd(uchar cNum, Uint * ipStartAdd, Uint * ipEndAdd); 

*        : ȡǰĩַ 

**************************************************************************/ 

void GetToneAdd(uchar cNum, uint * ipStartAdd, uint * ipEndAdd)

{  *ipStartAdd=caToneAdd[cNum*2];
  *ipEndAdd=caToneAdd[cNum*2+1]; 

} 

/************************************************************************** 

*    ԭ: void SetPLAY(uchar cNum); 


*        : 㲥 

**************************************************************************/ 

void SetPLAY(uchar cNum)

{  uint Add_ST, Add_ED;
  uchar Add_ST_H, Add_ST_L, Add_ED_H, Add_ED_L;  

 do
  {
     RdStatus();  

  }
 while((SR0_L&0x01)||(!(SR1&0x01))); //if(SR0_L^0==1){system Err}<CMD_Err==1>  

 ClrInt();  

 GetToneAdd(cNum, &Add_ST, &Add_ED);
    Add_ST_L=(uchar)(Add_ST&0x00ff);
    Add_ST_H=(uchar)((Add_ST>>8)&0x00ff);
    Add_ED_L=(uchar)(Add_ED&0x00ff);
    Add_ED_H=(uchar)((Add_ED>>8)&0x00ff);
    SPISendData(SET_PLAY);
    SPISendData(0x00);
    SPISendData(Add_ST_L);           //S7:S0  ʼַ
    SPISendData(Add_ST_H);           //S10:S8
    SPISendData(Add_ED_L);           //E7:E0  ַ
    SPISendData(Add_ED_H);           //E10:E8
    SPISendData(0x00);
    SS=1;
    Delay(10);               //ӳ10ms

 do
  {
     RdStatus();

  }
 while((SR0_L&0x01)||((SR1&0x04))); //if(SR0_L^0==1){system Err}<CMD_Err==1> 

}
/************************************************************************** 

*    ԭ: void ISD_Init(void); 

*        : ʼ 

**************************************************************************/ 

void ISD_Init(void)

{
  ISD_Reset();
    do
     {
        ISD_PU();
        RdStatus();
     }
        while((SR0_L&0x01)||(!(SR1&0x01)));   //if(SR0_L^0==1){system Err}<CMD_Err==1>
        ClrInt();
        ISD_CHK_MEM();
        ISD_WR_APC2( );
        RdAPC();
}
/****************ΪISDоƬӺ****************************/

 chuli()_task_ 1      //1ݴ
{
while(1) 
 { 
 wan=V/10000;   
 qian=V%10000/1000;
 bai=V%1000/100;
 shi=V%100/10;
 ge=V%10;
 os_send_signal(3);
 os_wait1(K_SIG);
 }
}
 
 display()_task_ 2   //2ʾ
 {
 while(1)
 {
 P0=0xff;
 P1=~0xfe;
 if(wan==0)   //λΪ0ʱ0
 P0=0xff;     //0
 else
 P0=tab[wan];
 if(w==0)     //λźΪ0
 P0_7=0;      //λʾС
 os_wait(K_TMO,1,0);
 
 P0=0xff;
 P1=~0xfd;   
 P0=tab[qian];
 if(q==0)    //ǧλźΪ0
 P0_7=0;     //ǧʾС
 os_wait(K_TMO,1,0);
 
 P0=0xff;
 P1=~0xfb;
 P0=tab[bai];
 if(b==0)    //λźΪ0
 P0_7=0;     //λʾС
 os_wait(K_TMO,1,0);
 
 P0=0xff;
 P1=~0xf7;
 P0=tab[shi];
 if(s==0)   //ʮλźΪ0
 P0_7=0;    //ʮλʾС
 os_wait(K_TMO,1,0);
 
 P0=0xff;
 P1=~0xef;
 P0=tab[ge];
 os_wait(K_TMO,1,0);
 }
}

Read()_task_ 3   //3
 {
 
 
 while(1)
 {
 //while(OVER)    //̼
 //{
 //ISD_PU();
 //SetPLAY(14);   //̾
 //ISD_PD();
 //}
 while(!READ)   //READʱ
  {
  os_delete_task(1);  //ʱ1бɾֹͣݴֹ
  
  ISD_PU();           //ISDϵ
  
 if(POL==0)           //ж
  SetPLAY(13);
  
 if(w==0)             //Сλ
  {
  SetPLAY(wan);
  SetPLAY(16);
  SetPLAY(qian);
  SetPLAY(bai);
  SetPLAY(shi);
  SetPLAY(ge);
  }
  
 
 if(q==0)             //Сǧλ
  {
   if(wan==0)
   {
    SetPLAY(qian);
   }
   else
   {
     SetPLAY(10);
     if(qian!=0)
     {
      SetPLAY(qian);
     }
   }
  SetPLAY(16);
  SetPLAY(bai);
  SetPLAY(shi);
  SetPLAY(ge);
  }
  
 if(b==0)             //Сڰλ
  {
   if(wan!=0&&qian==0&&bai==0)
    {
     SetPLAY(wan);
     SetPLAY(11);
    }
   if(wan!=1&&qian==0&&bai!=0)
    {
     SetPLAY(wan);
     SetPLAY(11);
     SetPLAY(0);
     SetPLAY(bai);
    } 
   if(wan!=0&&qian!=0&&bai==0)
    {
     SetPLAY(wan);
     SetPLAY(11);
     SetPLAY(qian);
     SetPLAY(10);
    }
   if(wan==0&&qian!=0&&bai!=0)
    {
     SetPLAY(qian);
     SetPLAY(10);
     SetPLAY(bai);
    }
   if(wan==0&&qian!=0&&bai==0)
    {
     SetPLAY(qian);
     SetPLAY(10);
    }
   if(wan!=0&&qian!=0&&bai!=0)
    { 
     SetPLAY(wan);
     SetPLAY(11);
     SetPLAY(qian);
     SetPLAY(10);
     SetPLAY(bai);
    }
  SetPLAY(16);
  SetPLAY(shi);
  SetPLAY(ge);
 }

if(s==0)    //Сʮλ
{
  if(wan==0&&qian==0&&bai==0&&shi!=0)
    {
    SetPLAY(shi);
    }
  if(wan==0&&qian==0&&bai!=0&&shi==0)
    {
     SetPLAY(bai);
     SetPLAY(10);
    }
  if(wan==0&&qian!=0&&bai==0&&shi==0)
    {
     SetPLAY(qian);
     SetPLAY(11);
    }
  if(wan!=0&&qian==0&&bai==0&&shi==0)
    {
     SetPLAY(wan);
     SetPLAY(12);
    }
  if(wan==0&&qian==0&&bai!=0&&shi!=0)
    {
     SetPLAY(bai);
     SetPLAY(10);
     SetPLAY(shi);
    }
  if(wan==0&&qian!=0&&bai==0&&shi!=0)
    {
     SetPLAY(qian);
     SetPLAY(11);
     SetPLAY(0);
     SetPLAY(shi);
    }
  if(wan==0&&qian!=0&&bai!=0&&shi==0)
    {
     SetPLAY(qian);
     SetPLAY(11);
     SetPLAY(bai);
     SetPLAY(10);
    }
  if(wan!=0&&qian==0&&bai==0&&shi!=0)
    {
     SetPLAY(wan);
     SetPLAY(12);
     SetPLAY(0);
     SetPLAY(shi);
    }
  if(wan!=0&&qian==0&&bai!=0&&shi==0)
    {
     SetPLAY(wan);
     SetPLAY(12);
     SetPLAY(0);
     SetPLAY(bai);
     SetPLAY(10);
    }
  if(wan!=0&&qian!=0&&bai==0&&shi==0)
    {
     SetPLAY(wan);
     SetPLAY(12);
     SetPLAY(qian);
     SetPLAY(11);
    }
  if(wan==0&&qian!=0&&bai!=0&&shi!=0)
    {
     SetPLAY(qian);
     SetPLAY(11);
     SetPLAY(bai);
     SetPLAY(10);
     SetPLAY(shi);
    }
  if(wan!=0&&qian==0&&bai!=0&&shi!=0)
    {
     SetPLAY(wan);
     SetPLAY(12);
     SetPLAY(0);
     SetPLAY(bai);
     SetPLAY(10);
     SetPLAY(shi);
     }
  if(wan!=0&&qian!=0&&bai==0&&shi!=0)
    {
     SetPLAY(wan);
     SetPLAY(12);
     SetPLAY(qian);
     SetPLAY(11);
     SetPLAY(0);
     SetPLAY(shi);
    }
  if(wan!=0&&qian!=0&&bai!=0&&shi==0)
    {
     SetPLAY(wan);
     SetPLAY(12);
     SetPLAY(qian);
     SetPLAY(11);
     SetPLAY(bai);
     SetPLAY(10);
    }
  if(wan!=0&&qian!=0&&bai!=0&&shi!=0)
    {
     SetPLAY(wan);
     SetPLAY(12);
     SetPLAY(qian);
     SetPLAY(11);
     SetPLAY(bai);
     SetPLAY(10);
     SetPLAY(shi);
    }
  SetPLAY(16);
  SetPLAY(ge);
}       
 
 ISD_PD();             //ISD
 os_create_task(1);   //´1ݴ
 }
  os_wait1(K_SIG);    //ʱ񣬵ȴ1ź
 }
}
initial() _task_ 0    //0ִ
{
 ISD_Init();          //ISDʼ
 ISD_PD();            //ISD
 TMOD=0Xd0;           //11010000  T1ڷʽ1ſؼ
 TL1=0;               //ֵ0
 TH1=0;
 ET1=1;
 EX1=1;
 IT1=1;
 EA=1;
 TR1=1;
 os_create_task(1);  //1
 os_create_task(2);  //2
 os_create_task(3);  //3
 os_delete_task(0);  //0бɾ
 }

void ADC_7135() interrupt 2  //ⲿж
{
 V=TH1;
 V<<=8;
 V+=TL1;   
 V-=10003;
 TL1=0;
 TH1=0;
 isr_send_signal(1);
 }





